/*
 * Copyright (C) 2013-2016 CERN (www.cern.ch)
 * Author: Tomasz Wlostowski <tomasz.wlostowski@cern.ch>
 * Author: Federico Vaga <federico.vaga@cern.ch>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifdef LIB_PRINTF
#include <stdio.h>
#include <stdint.h>
#include <string.h>

#include "pp-printf.h"
#include "mockturtle-rt-common.h"

/**
 * It sends a string over the debug interface
 */
int puts(const char *p)
{
	char c;
	int i = 0;

	while ((c = *(p++))) {
		lr_writel(c, WRN_CPU_LR_REG_DBG_CHR);
		++i;
	}

	/* Provide a string terminator */
	lr_writel('\0', WRN_CPU_LR_REG_DBG_CHR);

	return i;
}
#else
int puts(const char *p)
{
	return 0;
}
#endif
